/*!
* @file Quest.h
* @brief クエストのプロトタイプ
* @date 2013/12/11
* @author Deskull
* 2013 Sikabane Works.
*/

#include "stdafx.h"
#include "GameElement.h"

#pragma once

namespace Deeangband
{

	/*! 
	* @class Quest
	* @brief クエストのクラス
	*/
	class Quest : public GameElement
	{

	private:
		std::string name; //!< クエスト名

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param fileVersion ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int fileVersion) 
		{
			archive & BOOST_SERIALIZATION_NVP(name);
		}

	public:

		/*! 
		* @brief Questクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		Quest::Quest(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief Questクラスコンストラクタ
		*/
		Quest::Quest(void);

		/*! 
		* @brief Questクラスデストラクタ
		*/
		Quest::~Quest(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void Quest::SetDammyData(void);

	};

}